%define rname	qte
%define major	2
%define middle	3
%define minor	8
%define qtdir	%_libdir/%rname%major
%define snap	0

%if %snap
%define snapver 20050512
%endif

%define _optlevel 3

%set_gcc_version 3.3

Name: %rname%major
Version: %major.%middle.%minor
Release: alt1

Group: Development/KDE and QT
Summary: QtEmbedded toolkit
URL: http://www.trolltech.com/products/qt.html
License: GPL

Requires: gcc3.3-c++

%if %snap
Source: ftp://ftp.troll.no/qt/snapshots/qt-embedded-%major.%middle.%minor-snapshot-%snapver.tar.gz
%else
Source: ftp://ftp.troll.no/qt/source/qt-embedded-%version.tar.bz2
%endif
Source1: qte-cyr_fonts.tar.bz2

Patch: qte2-configs-no-rpath.patch

BuildRequires: libqt3-devel libstdc++-devel gcc-c++ libpng-devel zlib-devel
BuildRequires: gcc3.3-c++ kernel-headers-std

%description
QT/Embedded toolkit with Virtual Framebuffer
With included Cyrillic fonts

%prep
%if %snap
%setup -q -n qt-%version-snapshot-%snapver
%else
%setup -q -n qt-%version
%endif
%patch -p0

%define optflags_optimization -O%_optlevel %optflags_debug

subst "s/-O2/%optflags/g" configs/linux*
# subst "s/gcc$/gcc-3.3/g" configs/linux*
# subst "s/g++$/g++-3.3/g" configs/linux*

%build
export QTDIR=$(/bin/pwd)
export PATH=$QTDIR/bin:$PATH
export LD_LIBRARY_PATH=$QTDIR/lib:$LD_LIBRARY_PATH

echo "yes" |
./configure -shared -thread -qvfb -depths 4,8,16,24,32 -no-g++-exceptions \
	-no-xft -system-zlib -system-libpng

%make_build symlinks src-moc src-mt sub-src ###sub-tools sub-tutorial sub-examples

for i in makeqpf designer/uic; do
    %make_build -C tools/$i
done

export QTDIR=%_libdir/qt3
export GCC_VERSION=3.4
%make_build -C tools/qvfb SYSCONF_CXXFLAGS="-pipe -fno-exceptions -Wall -DGLX_GLXEXT_LEGACY $RPM_OPT_FLAGS" SYSCONF_LIBS_QT="-lqt-mt -lpng"

%install
export QTDIR=$(/bin/pwd)
export PATH=$QTDIR/bin:$PATH
export LD_LIBRARY_PATH=$QTDIR/lib:$LD_LIBRARY_PATH

# Create directories needed for installation
%__install -d %buildroot/%_bindir/
%__install -d %buildroot/%_libdir/
%__install -d %buildroot/%qtdir/bin/
%__install -d %buildroot/%qtdir/lib/
%__install -d %buildroot/%qtdir/include/
%__install -d %buildroot/%qtdir/lib/fonts/
%__install -d %buildroot/%_docdir/qte-%version/

# Install binaries...
%__install -m755 bin/* %buildroot/%qtdir/bin
%__install -m755 tools/makeqpf/makeqpf %buildroot/%qtdir/bin/
%__install -m755 tools/qvfb/qvfb %buildroot/%qtdir/bin/
%__cat <<EOF > %buildroot/%_bindir/makeqpf-qte
#!/bin/sh
export QTDIR=%qtdir
\$QTDIR/bin/makeqpf -qws \$*
EOF
%__chmod 755 %buildroot/%_bindir/makeqpf-qte

# Install shared libraries...
%__install -m644 lib/libqte.so.%version %buildroot/%_libdir/
%__install -m644 lib/libqte-mt.so.%version %buildroot/%_libdir/

# ...creating links
pushd %buildroot/%qtdir/lib
ln -s ../../libqte-mt.so.%version libqte-mt.so.%version
ln -s ../../libqte-mt.so.%version libqte-mt.so
ln -s ../../libqte-mt.so.%version libqte-mt.so.%major.%middle
ln -s ../../libqte.so.%version libqte.so.%version
ln -s ../../libqte.so.%version libqte.so
ln -s ../../libqte.so.%version libqte.so.%major.%middle
popd

# Install fonts...
%__install -m644 lib/fonts/{unifont*.qpf,micro*.qpf,README} %buildroot/%qtdir/lib/fonts/
%__tar xfvj %SOURCE1
%__cp -a lib/fonts/mkfontdir-qws qte-cyr_fonts/* %buildroot/%qtdir/lib/fonts/
echo >> %buildroot/%qtdir/lib/fonts/fontdir
echo "micro micro.bdf BDF n 50 40" >> %buildroot/%qtdir/lib/fonts/fontdir
echo "unifont unifont.bdf BDF n 50 160 u" >> %buildroot/%qtdir/lib/fonts/fontdir

pushd %_builddir/%buildsubdir/include
    find . -type l -exec cp -v {} %buildroot/%qtdir/include \;
    find . -type f -exec cp -v {} %buildroot/%qtdir/include \;
popd

# hack for OPIE
for f in qgfx_qws.h qwsmouse_qws.h qcopchannel_qws.h qwindowsystem_qws.h \
	 qfontmanager_qws.h qwsdefaultdecoration_qws.h; do
    %__install -m644 src/kernel/$f %buildroot/%qtdir/include/
done
touch %buildroot/%qtdir/stamp-headers

cp %_builddir/%buildsubdir/FAQ %buildroot/%_docdir/qte-%version/
cp %_builddir/%buildsubdir/LICENSE.GPL %buildroot/%_docdir/qte-%version/
cp %_builddir/%buildsubdir/PLATFORMS %buildroot/%_docdir/qte-%version/
cp %_builddir/%buildsubdir/README %buildroot/%_docdir/qte-%version/
cp %_builddir/%buildsubdir/changes-* %buildroot/%_docdir/qte-%version/

# Create menu entry for Qt/Embedded VirtualFB
%__install -d %buildroot/%_menudir/
%__cat <<EOF > %buildroot/%_menudir/%name-qvfb
?package(%name-qvfb): needs=X11 \
section="Applications/Development/Tools" \
title="QtEmbedded VFB" \
longtitle="QtEmbedded Virtual Framebuffer" \
command="%qtdir/bin/qvfb"
EOF

%set_strip_method executable

%post
/sbin/ldconfig
%update_menus

%postun
/sbin/ldconfig
%clean_menus

%files
%dir %qtdir
%qtdir/lib
%_libdir/libqte*
%_bindir/makeqpf-qte
%_menudir/%name-qvfb
%qtdir/bin
%qtdir/include
%qtdir/lib/libqte*
%qtdir/stamp-headers
%_docdir/qte-%version

%changelog
* Thu May 12 2005 Kachalov Anton <mouse@altlinux.ru> 2.3.8-alt1
- 2.3.8

* Mon Apr 05 2004 Kachalov Anton <mouse@altlinux.ru> 2.3.7-alt1
- first build for Sisyphus
